import numpy as np
import os
import yaml
import pickle

from envs.env import NavigationEnv

def collect_eval_data(n_epi=1, map_path=None, config=None, filename=None):
    data_list = []
    env = NavigationEnv(path=map_path, config=config)
    n_human = config['num_humans']

    for _ in range(n_epi):
        env.reset()
        data = [(env.car.x, env.car.y, env.car.yaw), env.target]
        human_list = []
        for i in range(n_human):
            human_i_pos = env.humans_pos[i]
            human_list.append(human_i_pos)
        data.append(human_list)
        data_list.append(data)

    return data_list

def save_eval_data(data, filename):
    with open(filename, 'wb') as f:
        pickle.dump(data, f)

def load_eval_data(filename):
    data = None
    with open(filename, 'rb') as f:
        data = pickle.load(f)
    return data


if __name__ == '__main__':
    mode = 'save'
    
    filename = "eval_data/eval_random_1k_data.pkl"
    config = None
    with open('configs.yaml') as f:
        config = yaml.load(f, Loader=yaml.FullLoader)

    if mode == "save":
        data_list = collect_eval_data(
            n_epi=1000,
            map_path=config['map_path'],
            config=config,
            filename=filename
        )
        save_eval_data(data_list, filename)

    elif mode == "load":
        data = load_eval_data(filename)
        print()
